/**
 * qunit mocha compatibility layer
 *
 * Copyright (C) 2015 Andras Radics
 * Licensed under the Apache License, Version 2.0
 */

// FIXME: work in progress, builds wrong structure

'use strict';

var testObject = { };

global.describe = function( name, suite ) {
    var enclosingObject = testObject;

    // build the describe() hierarchy into a new testObject
    testObject = { };
    suite();

    // attach the new tests to the existing hierarchy
    if (testObject._suite) {
        testObject[name] = testObject._suite;
        delete testObject._suite;
    }

    enclosingObject[name] = testObject;
    testObject = enclosingObject;
};

global.before = function before( cb ) {
    testObject.setUp = cb;
};

global.after = function after( cb ) {
    testObject.tearDown = cb;
};

global.it = function it( name, test ) {
    if (!testObject._suite) testObject._suite = { };
    testObject._suite[name] = function(t) {
        test(function(){ t.done() });
    }
};

global.beforeEach = function beforeEach( cb ) {
    if (!testObject._suite) testObject._suite = { };
    testObject._suite.setUp = cb;
};

global.afterEach = function afterEach( cb ) {
    if (!testObject._suite) testObject._suite = { };
    testObject._suite.tearDown = cb;
};


module.exports.reset = function() { testObject = { } };
module.exports.getHierarchy = function() { return testObject };
