qunit = require('../index');
qmocha = require('../lib/mocha-compat');

var printf = qunit.QUnit.prototype.printf;

describe('describe suite', function() {

    before(function(done) {
        printf("top before\n");
        done();        
    });

    after(function(done) {
        printf("top after\n");
        done();
    });

    beforeEach(function(done) {
        printf("top before each\n");
        done();
    });

    afterEach(function(done) {
        printf("top after each\n");
        done();
    });

    it('test 1', function(done) {
        printf("test 1\n");
        done();
    });

    it('test 2', function(done) {
        printf("test 2\n");
        done();
    });

    describe('nested describe suite', function() {

        before(function(done) {
            printf("nested before\n");
            done();        
        });

        after(function(done) {
            printf("nested after\n");
            done();
        });

        beforeEach(function(done) {
            done();
        });

        afterEach(function(done) {
            done();
        });

        it('nested test 1', function(done) {
            printf("nested test 1\n");
            done();
        });

        it('nested test 2', function(done) {
            printf("nested test 2\n");
            done();
        });

    });

});

printf("%10O\n", qmocha.getHierarchy());

var options = {};
var stats = {
    assertionCount: 0,
    fileCount: 0,
    errors: new Array(),
};
qunit.runTest(qmocha.getHierarchy(), "", options, [], [], stats, function(err) {
    console.log("DONE", err);
});
